/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jogoDaMemoria;

import JPlay.Animation;
import JPlay.GameImage;
import JPlay.Keyboard;
import JPlay.Mouse;
import JPlay.Time;
import JPlay.Window;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;

/**
 * @author Gefersom Cardoso Lima
 * Universidade Federal Fluminense - UFF - Brasil - 2010
 * Ciência da Computação
 */

public class TelaMensagemFimJogo
{
    Window window;
    Time tempo;
    Keyboard keyboard;
    Animation botao;
    GameImage backGround;
    Mouse mouse;
    boolean clicouNoBotao;
    Font fonteDaMensagemFinal;

    public TelaMensagemFimJogo(Window window, Time tempo)
    {
            this.window = window;
            this.tempo = tempo;
            this.keyboard = window.getKeyboard();
            this.mouse  = window.getMouse();
            this.botao = new Animation("botao.png", 5);
            this.backGround = new GameImage("fundoBotao.png");
            this.fonteDaMensagemFinal = new Font("Comic Sans MS", Font.TRUETYPE_FONT, 12);

            //Faz uma cópia da dimenão da janela.
            Dimension dimensaoAnteriorDaJanela = (Dimension) window.getSize().clone();           

            setarConfiguracoes();
            loop();
            descarregarObjetos();

            //Restaura dimensão da janela.
            redimensionarJanela(dimensaoAnteriorDaJanela);
    }

    private void setarConfiguracoes()
    {
            redimensionarJanela(new Dimension(300,150));

            botao.setTimeChangeFrame(100);
            botao.setPosition((window.getWidth() - botao.width)/2, 50);
            botao.setRangeOfFrames(0, 4);

            clicouNoBotao = false;
    }

    private void loop()
    {
            boolean executando = true;

            while(executando)
            {                   
                    if (mouse.isOverObject(botao) && mouse.isLeftButtonPressed() )
                        clicouNoBotao = true;
                    
                    if (clicouNoBotao)
                        botao.runAnimation();

                    if (keyboard.keyDown(Keyboard.ESCAPE_KEY) || botao.isAnimationFinished() )
                        executando = false;

                    desenhar();
            }
    }

    private void desenhar()
    {
            backGround.draw();
            botao.draw();
            window.drawText("Você conseguiu em: " + tempo.toString() + "!",70, 50, Color.YELLOW, fonteDaMensagemFinal);

            //Esse método SEMPRE deve ser chamado por último.
            window.display();
    }

    private void descarregarObjetos()
    {
            backGround = null;
            botao = null;
            tempo = null;
            keyboard = null;
            mouse = null;                                          
    }

    private void redimensionarJanela(Dimension dimensao)
    {
            //Primeiro escondemos a janela, para o jogador não a ver sendo
            //redimensionada.
            window.setVisible(false);
            window.setSize(dimensao);

            //Centraliza a janela no meio da tela.
            window.setLocationRelativeTo(null);            
            
            //Atraso para voltar a tela anterior, isso irá evitar que a tela
            //pisque muito rápido.
            window.delay(300);

            //Depois de redimensionar volta a mostrar a janela
            window.setVisible(true);
    }
}
